/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

Etype *se_FunctionStmt_etype;
char  *se_FunctionStmt_name;

char *fun_name (name)  /* $name_sub */
char *name;
{
    char *str;
	char *tname;
	T_Entry *entry;

	if ((entry = lookup_all (name)) == TN)
		SYSERR;

	tname = entry->orig_name;

    str = (char*) U_malloc (strlen (tname) + 1 + 4 + 1);
    strcpy (str, "@");
    strcat (str, tname);
    strcat (str, "_sub");

    return str;
}

fun_subscript_output (sub, entry, write, interf_entry)  /* writes or parses subscript */
Node *sub;
T_Entry *entry, *interf_entry;
int write;
{
	Node *temp, *stmt;
	Node *expr = sub->Subscript.Expr;
	int type;
	Shape *shape;
	T_Entry *subentry;
	int replace_by_temporary = 0;

	if (sub->Subscript.Label != NN) {
		if (write) {
			oTIMES ();
			write_pass (sub->Subscript.Label);
		}

		return;
	}
	else
		type = expr->com.type;

	if (entry != TN && IS_elemental (entry)) {  /* function is elemental */
		if (write) {
			if (sub->Subscript.Expr1 == NN) {
				write_pass (expr);
			}
			else {
				write_pass (sub);
			}
		}
	}
	else if ((shape = expr->com.typ->shape) != (Shape*) 0) {  /* function has shape */
		if (type == DUM_EXPR) {  /* argument is expression */
			replace_by_temporary = 1;
		}
		else if (type == ARRAY_SECTION) {  /* argument is array section */
			char *name = expr->ArraySection.Name->com.str;
			Node *asublist = expr->ArraySection.SubscriptList, *asub;

			subentry = lookup_loc (name);
			if (typ_shape_eq (expr->com.typ->shape
			                , subentry->typ->shape)) {
				if (write) {
					if (IS_automatic (subentry) || IS_alloc_temp (subentry)) 
						auto_write_arg (expr->ArraySection.Name);
					else{

						onam (name);
                                          /* BOZKUS */
                                         /* TO write lb and ub for nCUBE */
                                               if(IS_npac_intrinsic(entry))
                                                          write_lb_ub(name);
					      }
				}
			}
			/*!!! doesn't work if a (3, :, 4)
			else if (shape->rank == 1) {
				Node *asub = LIST_FIRST_ELE (asublist);

				if (asub->Subscript.Expr2 == NN) {
					asub->Subscript.Expr1 = NN;
					asub->Subscript.Colon = NN;
					if (write)
						write_pass (sub);
				}
				else {
					replace_by_temporary = 1;
				}
			}
			*/
			else {
				replace_by_temporary = 1;
			}
		}
		else if (type == DUM_ARR_CONS) {
			char *name = expr->DumArrCons.Expr->com.str;

			if (write && expr->DumArrCons.ac->isconstant == 0) {
				ostart ();
				write_ArrayConstructor (expr->DumArrCons.ac);
				oend ();
			}

			subentry = lookup_loc (name);
			if (typ_shape_eq (expr->com.typ->shape
			                , subentry->typ->shape)) {
				if (write) {
					if (IS_automatic (subentry) || IS_alloc_temp (subentry)) 
						auto_write_arg (expr->DumArrCons.Expr);
					else
						onam (name);
				}
			}
			else {
				replace_by_temporary = 1;
			}
		}
		else {
			replace_by_temporary = 1;
		}
	}
	else {
		if (write) {
			if (type == NAME && (subentry = lookup_loc (expr->com.str)) != TN
			 && (IS_automatic (subentry) || IS_alloc_temp (subentry)))
				auto_write_arg (expr);
			else
				write_pass (sub);
		}
	}

	if (replace_by_temporary) {
		if (write) {
			SYSERR;
		}
		else {
			if (sub->Subscript.Expr->com.type == ARRAY_SECTION) {
				if (interf_entry == TN
				||  !IS_intent_set (interf_entry) || IS_intent_inout (interf_entry))
					sub->Subscript.Expr = temp_replace_inout (sub->Subscript.Expr);
				else if (IS_intent_in (interf_entry))
					sub->Subscript.Expr = temp_replace_in (sub->Subscript.Expr);
				else if (IS_intent_out (interf_entry))
					sub->Subscript.Expr = temp_replace_out (sub->Subscript.Expr);
			}
			else
				sub->Subscript.Expr = temp_replace (sub->Subscript.Expr);
		}
	}
}

static out_of_array_section (node)
Node *node;
{
/* use that it is walking from top-down */
}

fun_out_of_assig (node)
Node *node;
{
	int i, type;
	Node *child, *temp, *stmt, *name;
	T_Entry *entry;

	if (node == (Node*) 0)
		return;

	type = node->com.type;

	switch (node_class (type)) {

		case LIT:
		case TERM:
			break;

		case NONTERM:
			for (i = 0; i < node_nodes (type); i++) {
				if ((child = node->com.node[i]) == NN)
					continue; 

				if (child->com.type == FUNCTION_REFERENCE
				&& (entry = lookup_glo (child->com.str)) != TN 
				&& (
				  !IS_elemental (entry)
				  || (child->com.typ->shape == SN || child->com.typ->shape == 0)
				   )
				) {
					node->com.node [i] = temp_replace (child);
				}

				else if (child->com.type == ARRAY_SECTION) {
                                       
					out_of_array_section (node->com.node [i]);
				}

				else {
					fun_out_of_assig (node->com.node[i]);
				}
			}
			break;

#ifdef CHECK
		default:
			SYSERR;
#endif
	}
}

fun_end () /* installs... */
{
	T_Entry *entry, *new_entry;

	for_TABLE_LOOP_intrin (entry)
		if (IS_function (entry) && IS_array (entry)) {
			if (lookup_glo (fun_name (entry->orig_name)) != TN)
				continue;
			new_entry = install_glo (fun_name (entry->orig_name), TAB_NAME, 0);
			SET_temporary (new_entry);
		}

	for_TABLE_LOOP_glo (entry)
		if (IS_function (entry) && IS_array (entry)) {
			if (lookup_glo (fun_name (entry->orig_name)) != TN)
				continue;
			new_entry = install_glo (fun_name (entry->orig_name), TAB_NAME, 0);
			SET_temporary (new_entry);
		}
}











